eole-proxy - Tache #33458
Scénario # 33299 (Terminé (Sprint)): Etude Proxy 2.8.1 krb5

Etude
29/11/2021 14:12 - Emmanuel GARETTE

Statut: Fermé Début: 15/11/2021

Priorité: Normal Echéance:

Assigné a: Emmanuel GARETTE % réalisé: 100%

Version cible: Prestation Cadoles MEN 2021 46-49 Temps estimé: 0.00 heure
Temps passé: 0.00 heure

Description

Historique

#1 - 29/11/2021 14:13 - Emmanuel GARETTE

- Statut changé de Nouveau a En cours

#2 - 29/11/2021 16:13 - Emmanuel GARETTE
Démarrage de I'environnement :
etb1.amon-2.8.1-instance-default
etb1.scribe-2.8.1-instance-Aveclmport
etb1.pcprofs-10.21H1

Si Amon :

apt install krb5-user msktutil

Le template /usr/share/eole/creole/distrib/proxy.krb5.conf :

[libdefaults]
default_realm = %%nom_domaine_krb.upper ()
dns_lookup_realm = false

dns_lookup_kdc = false

default_keytab_name = FILE:/etc/squid/HTTP.keytab

default_etypes = aes256-cts—hmac-shal-96 aesl28-cts-hmac-shal-96 arcfour-hmac-md5 des-cbc-crc des-cbc-md5
default_tgs_enctypes = aes256-cts—-hmac-shal-96 rc4-hmac des-cbc-crc des—-cbc-mdb

default_tkt_enctypes = aes256-cts-hmac-shal-96 rc4-hmac des-cbc-crc des-cbc-md5

permitted_enctypes = aes256-cts-hmac-shal-96 rc4-hmac des-cbc-crc des-cbc-md5
[realms]

$%nom_domaine_krb.upper () = {

kdc = %$%nom_serveur_krb.%$%nom_domaine_krb:88

admin_server = $%nom_serveur_krb.%$%$nom_domaine_krb:749

default_domain = %$%nom_serveur_krb.%$%$nom_domaine_krb

}

[domain_realm]
$nom_domaine_krb.upper ()

.%%nom_serveur_krb.%$%nom_domaine_krb = %
$%nom_serveur_krb.%$%nom_domaine_krb = $%$nom_domaine_krb.upper ()

Le template /usr/share/eole/creole/distrib/smb-proxy_auth.conf :

[global]

# Oblige samba d’encrypter les échanges avec mot de passe chiffré
encrypt passwords = true

# Nom NetBios de la machine serveur squid

%$if %$%mode_conteneur_actif == 'non'
netbios name = %$%nom_machine

%else
netbios name = %$%container_name_proxy
interfaces = %%adresse_ip_ethl_proxy_link
%end if
server string = %$h server (Samba %v)
# Amon n'a pas vocation a étre contréleur principal d'un domaine
local master = no
domain master = no
preferred master = no
os level = 0
# La plage uid/gid pour le mappage des comptes windows
winbind uid = 10000-20000
winbind gid = 10000-20000
winbind use default domain = yes

$if $%type_squid_auth == 'NTLM/SMB'
%$set $%workgroup = $%nom_domaine_smb
%$set %$%security = "domain"
%set %$%password = $%nom_serveur_smb
%else if $%type_squid_auth == 'NTLM/KERBEROS'
%$set %$%workgroup = %$%$nom_domaine_windows
%$set %$%security = "ADS"
%$set %$%password = $%$lower ($%nom_serveur_krb+"."+%$%nom_domaine_krb)

%end if

# Configuration du domaine
workgroup = $%$%upper ($%workgroup)
security = %%security
password server = %%password

%if %%type_squid_auth == 'NTLM/SMB'
wins server = %%ip_serveur_smb

%$else if %$%type_squid_auth == 'NTLM/KERBEROS'
realm = $%upper ($%nom_domaine_krb)
kerberos method = secrets and keytab

%end if

Modifier le template /usr/share/eole/creole/distrib/01squid.conf :
Remplacer le bloc :

$if $%type_squid_auth == 'NTLM/KERBEROS'

auth_param ntlm program /usr/bin/ntlm_auth --helper-protocol=squid-2.5-ntlmssp
auth_param ntlm children %%number_of_ntlm_children

#auth_param ntlm max_challenge_reuses 0

#auth_param ntlm max_challenge_lifetime 2 minutes

auth_param basic program /usr/bin/ntlm_auth --helper-protocol=squid-2.5-basic

%end if
Par :
$if $%type_squid_auth == 'NTLM/KERBEROS'

auth_param negotiate program /usr/lib/squid/negotiate_kerberos_auth -d -s "HTTP/%$%nom_machine.%%nom_domaine_kr
b@%%nom_domaine_krb.upper ()"

auth_param negotiate children %$%number_of_ntlm_children

auth_param negotiate keep_alive on

auth_param basic program /usr/bin/ntlm_auth --helper-protocol=squid-2.5-basic
%end if

Dans le fichier /usr/share/eole/creole/dicos/23_proxy.xml
Ajouter aprés :

<file filelist='kerberos' name='/etc/samba/lmhosts' mkdir='True'/>

La ligne :
<file filelist='kerberos' name='/etc/krb5.conf' source="proxy.krb5.conf"/>

Faire reconfigure

root@amon:~# kinit Administrator@DOMPEDAGO.ETB1.LAN
Password for Administrator@DOMPEDAGO.ETB1.LAN:
root@amon:~# klist

Ticket cache: FILE:/tmp/krb5cc_0

Default principal: Administrator@DOMPEDAGO.ETB1.LAN

Valid starting Expires Service principal
29/11/2021 16:15:13 30/11/2021 02:15:13 krbtgt/DOMPEDAGO.ETB1.LAN@DOMPEDAGO.ETB1.LAN
renew until 30/11/2021 16:15:03

msktutil -c -b "CN=COMPUTERS" -s HTTP/amon.dompedago.etbl.lan -h amon.dompedago.etbl.lan -k /etc/squid/HTTP.ke
ytab —-—-computer—-name squid-http —--upn HTTP/amon.dompedago.etbl.lan --server addc.dompedago.etbl.lan —--verbose

—-—enctypes 28

Vérification du ticket :

root@amon:~# klist -ke /etc/squid/HTTP.keytab

Keytab name: FILE:/etc/squid/HTTP.keytab

KVNO Principal

squid-http$@DOMPEDAGO.ETB1.LAN (arcfour-hmac)
squid-http$@DOMPEDAGO.ETB1.LAN (aesl28-cts-hmac-shal-96)
squid-http$E@DOMPEDAGO.ETB1.LAN (aes256-cts-hmac-shal-96)
SQUID-HTTPS@DOMPEDAGO.ETB1.LAN (arcfour-hmac)
SQUID-HTTPS@DOMPEDAGO.ETB1.LAN (aesl28-cts-hmac-shal-96)
SQUID-HTTPS@DOMPEDAGO.ETB1.LAN (aes256-cts-hmac-shal-96)
HTTP/amon.dompedago.etbl.lan@DOMPEDAGO.ETB1.LAN (arcfour-hmac)
HTTP/amon.dompedago.etbl.lan@DOMPEDAGO.ETB1.LAN (aesl28-cts-hmac-shal-96)
HTTP/amon.dompedago.etbl.lan@DOMPEDAGO.ETB1.LAN (aes256-cts-hmac-shal-96)
host/amon@DOMPEDAGO.ETB1.LAN (arcfour-hmac)

host/amon@DOMPEDAGO.ETB1.LAN (aesl28-cts—hmac-shal-96)
host/amon@DOMPEDAGO.ETB1.LAN (aes256-cts-hmac-shal-96)
host/amon.dompedago.etbl.lan@DOMPEDAGO.ETB1.LAN (arcfour-hmac)
host/amon.dompedago.etbl.lan@DOMPEDAGO.ETB1.LAN (aesl28-cts—hmac-shal-96)
host/amon.dompedago.etbl.lan@DOMPEDAGO.ETB1.LAN (aes256-cts-hmac-shal-96)

[C,C, BN, BN, BN G, BN, N C, BNC, INC, BN, BN G, BN G BN G, R €, B, ]

On a bien le principale "HTTP/amon.dompedago.etb1.lan@DOMPEDAGO.ETB1.LAN" encodé en "aes256-cts-hmac-sha1-96"

Tester le fonctionnement depuis I'Amon :

root@amon:~# kinit -k -t /etc/squid/HTTP.keytab HTTP/amon.dompedago.etbl.lan@DOMPEDAGO.ETB1.LAN
root@amon:~# klist

Ticket cache: FILE:/tmp/krb5cc_0

Default principal: HTTP/amon.dompedago.etbl.lan@DOMPEDAGO.ETB1.LAN

Valid starting Expires Service principal
03/12/2021 12:07:50 03/12/2021 22:07:50 krbtgt/DOMPEDAGO.ETB1.LANGDOMPEDAGO.ETB1.LAN
renew until 04/12/2021 12:07:50

root@amon:~# /usr/lib/squid/negotiate_kerberos_auth_test amon.dompedago.etbl.lan | awk '{sub(/Token:/,"YR"); p

rint $0}END{print "QQ"}'|/usr/lib/squid/negotiate_kerberos_auth -d -k /etc/squid/HTTP.keytab -s
edago.etbl.lan@DOMPEDAGO.ETB1.LAN

negotiate_kerberos_auth.cc(489): pid=15838 :2021/12/03 12:08:35| negotiate_kerberos_auth: INFO:
on 3.1.0sg

negotiate_kerberos_auth.cc (548): pid=15838 :2021/12/03 12:08:35| negotiate_kerberos_auth: INFO:
to /etc/squid/HTTP.keytab

negotiate_kerberos_auth.cc(571): pid=15838 :2021/12/03 12:08:35| negotiate_kerberos_auth: INFO:
to MEMORY:negotiate_kerberos_auth_15838

negotiate_kerberos_auth.cc(612): pid=15838 :2021/12/03 12:08:35| negotiate_kerberos_auth: DEBUG:

HTTP/amon .domp
Starting versi
Setting keytab
Changed keytab

Got 'YR YIIGd

AYGKwYBBQUCoIIGaDCCBmSgDTALBgkghkiGI9xIBAgKiggZRBIIGTWCCBkkGCSgGSIb3EgECAGEALOIGODCCBjSgAWIBBaEDAGEOOgCDBQAAAAA
A04IFLWGCBSkwggUloAMCAQWhEFBsSREINUEVEQUAPLkVUQJEUTEFO01 IwIKADAGEDORKkWEXxSESFRUUBSPcGVkYWAvLmVOY jEubGFuo4IE4jCCB
N6gAwWIBEQEDAGEGOOIEOASCBMYyAWONhossCXTGOWNKsXzhbP2sWoY £ jiONhEp79vBVVOAYH60r2K0r1Kdouh3H4fFCHLix/GdmrgKCrv0+usI
uGjtt8h+2m2XjnJZnDx1WGymt 0aQixoE/u05zkVHOM8vIN1IP fQZmMI0AC5eQROPM5BkGTZzzd33w5007Uc94PpLIiJ77e3WPS6VSKR5HbBaXzUw
mailto:HTTP/amon.dompedago.etb1.lan@DOMPEDAGO.ETB1.LAN

19J1138ImZnAtxxJImEQUUHSDOEKrNhg7QIt+TauTkEnG7TcfUpeWdkVP70UjamDrGogfFK52AA3BRzt1£d1l 9gXMGMAVEV2IVtrhBd5GelzlcZ
A6sxBsKGLk20bjkUikmSifHQFDyd3QngOHskGN/hHIM1S749XajxJ2 juul3pzgOgBbeKfn/6+87QmcIv18ppfzUglQAovSIniwkxf2JHCT8EwWYZ
BibPAiGxS6kPPRBC2bFhkoZ2LVWM2WUUIAHIOpxxXFgfKZUBDmE1yRnI5dUP6Z3Wyk0kREfXg9D1Pax7XxnwnChBgP2+4CSKomg6XJ3PpmFnU92
0zJ5M5CJ0Sns2gQRA3HL2TIkgqItxE+y0ujPGUEdorvhbQY10bg2QadW/ 7mhbhQ74F /tbU49/4gMRQt ybRMy8oRWmeyJJ1E3cThCYDFuvCxONSze
D8Sfxs/xpmcXM2yiTnc+XeCU3xb2WpsoyF1g5PXv1AVanm33Z1TQizb+DnXTdjJzmCvsr1MJI8S+Ldn8ud0yIR8wnVmUeiBY2vRaLwGLG9eihT/
v60S76NUTNbOGktpI41QtP9cwPYttg/HphAAHg1KzU80M1l juB5SfFr7xrTy0eMiR2yC35aRrIV6TMIbKzsrGtycMO6AgDEf6vhxdn5+J6VIzulWe
1kbGEG8JfZxh4F1IMNhImME4AKpBtErF82R6ULKYwxxYcUbOSHF+NOuFQc90ohi0TOND68HS8XTWaenaCiFRvQW3VXmQ/JzC9zcCtO0PLf6ZLLjnjN3
6D1nPQgFAdhlFdjFwzd718GAaCPoMbgEZN7j/0dKN10J9YgefywnJewWCFe91S6QAVb+SR/ g7 fMwR38xYNaCGL0O jOBggz5NrHaBm/2q/h8RAF2
Bldgepg09d6Z0P8hYbji8Zw6/7ppnUU9JIMlaFW+n2hMnD78/hfx461TMAnjtwS5r+qOvaL81l£f95SE692vxyFdsuDGSK7792105/9eMBVk+rJo3y
0j3F1Sik0zj1l+D4I/DpYyFLVd7q/FSZLTItKxHbZJpUyrDAhir7BDktMzIROhhKBdnc8XYAfBuytB5CYel11L.9780sPg5iR+5a0rMDkgXAS5jOH
R/Y3tNTXqvXDalfNcI3bRevwcMnnSR8sFVMErOWwIpPvzIRUL9Ieuc7ThKROwyuvcKsse johxK21y934h93RMCSBP1vNScITXTNseYHK8vt 5EJp
E1+1JES5WDLgMWAXIn/sF4ipBFdNulhSMV47xKJWHoSinzbNieQ3D51iDV8LRthE jTzbKY6ArflaNaivKdeczcnlRiu89/kLEHGkBHPnjSC6a+MW
ScybjewPQVelCmDHx/R2X090GVHHIMr5K23fLVMEbgWTytBQ4YazMHMAX 9aYbyPtcswQKH16CKP4Eu/c9at9/vLi6VMkvRHx JHhf1L500hbUl £
FBW/M++cd3HZkpIHtMIHqoAMCARKigeIEgd/gSvCxrEJxWKbmXZvQ/CRXPP2rFU/CyfnnLlrSeXROn7pGL+s23JUHMFz8/Gth31plwOPLHL jhs
azQqH/4U03B1GZunj/2Lph21QvJSXuaw6lxzrfygq9BH1Ha7n9CH+jPsuPWtB23hRREZtAUW8QbrzcENfJ5rBe9aNFs/dd0zL5ukoJhx40X0gJdd
0OgUryghS4ZqvMs/c8Y17gTwmS2KkPbyi6MF8DE jiqUZsXfTkACRvV1YMs80soIehlsPkAkKbMcm+Pdg+KQ3y+Y14ThgwrepDt55JoswX2meS0UH
Hh/' from squid (length: 2211).
negotiate_kerberos_auth.cc(678): pid=15838 :2021/12/03 12:08:35| negotiate_kerberos_auth: DEBUG: Decode 'YIIGd
AYGKwYBBQUC0IIGaDCCBmSgDTALBgkghkiGIxIBAgKiggZRBIIGTWCCBkkGCSgGSIb3EgECAGEALoIGODCCBjSgAwWIBBaEDAgEOOgCDBQAAAAA
A04IFLWGCBSkwggUloAMCAQWhEBsSREINUEVEQUAPLkVUQJEUTEFO0i IwWIKADAgGEDORKWEFxSESFRUUBSPcGVkYWdAvLmVOY jEubGFuo4IE4 jCCB
N6gAwIBEQEDAGEGOOIEOASCBMyAWONhossCXTGOwWNKsXzhbP2sWoY jfji0NhEp79vBVVOAYH60r2K0r1Kdouh3H4fFCHLix/GdmrgKCrv0+usI
uGjtt8h+2m2XjnJZnDx1WGymt 0aQixoE/u05zkVHOm8vIN1IPfQZmMI0AC5eQROPM5BkGTzzd33w5Q07Uc94PpLIiJ77e3WPS6VSKR5HbBaXzUw
19J11ij8ImZnAtxxJ1ImEQUUHSDOEKrNhg7QIt+TauTkEnG7TcfUpeWdkVP 70U jamDrGogqfFK52AA3BRzt1fd1l 9gXMGMAVEV2IVtrhBd5Gelzlcz
A6sxBsKGLk20bjkUikmSifHQFDyd3QngOHskGN/hHIM1S749XajxJ2 juu3pzgOgBbeKfn/6+870mcIv18ppfzUglQAovSIniwkxf2JHCT8EwWYZ
BibPAiGxS6kPPRBC2bFhkoZ2LVwWM2WUUIAHI OpxxXFgfKZUBDmME1lyRnJISdUP6Z3WykO0kREXgI9D1Pax7XxnwnChBgP2+4CSKomg6XJ3PpmEnU92
0zJ5M5CJ0Sns2gQRA3Hb2IkqItxE+y0ujPGUEdorvhbQY10bg2QadW/7mhbhQ74F /tbU49/4gMRQt ybRMy8oRWmeyJJ1E3cThbCYDFuvCxONS5ze
D8Sfxs/xpmcXM2yiTnc+XeCU3xb2WpsoyF1g5PXv1AVanm33Z1TQizb+DnXTdjJzmCvsr1MJI8S+Ldn8ud0yIR8wnVmUeiBY2vRaLwGLG9eihT/
v60S76NUTNbOGktpI41QtP9cwPYttg/HphAAHglKzU80M1 juB5fFr7xrTy0eMiR2yC35aRrIV6TMIbKzsrGtycM06AgDEf6vhxdn5+J6V9zuWe
1kbGEG8JfZxh4F1MNh1ImME4KpBtErF82R6ULKYwxxYcUbOSHF+NOUuFQc90hi 0TOND68HS8XTWaenaCiFRvaW3VXmQ/JzC9zcCtOP£6ZLLjnjN3
6D1nPQgFAdhlFdjFwzd7i8GAaCPoMbgEZN7j/0dKN10J9YgefywnJewWCFe91S6QAVb+SR/ g7 fMwR38xYNaCGL0 jOBggz5NrHaBm/2q/h8RAF2
Bldgepg09d6Z0P8hYbji8Zw6/7ppnUU9IMlaFW+n2hMnD78/hfx461TMANjtw5r+qOvaL81lf95SE692vxyFdsuDGSK77gq2105/9eMBVk+rJo3y
033F1Sik0zj1+D4TI/DpYyFLVd7q/FSZLTItKxHbZJpUyrDAhir7BDktMz IROhhKBAnc8XYAfBuytB5CYel111L9780sPg5iR+5a0rMDkgXAS5j0H
R/Y3tNTXqvXDalfNcI3bRevwcMnnSR8sFVMErOWwIpPvzIRUL9Ieuc7ThKROwyuvcKsse johxK21y934h93RMCSBP1vNScITXTNseYHK8vt 5SEJp
E1+1JES5WDLgMWAXIn/sF4ipBFdNulhSMV47xKJWHoSinzbNieQ3D5iDV8LRthEjTzbKY6ArflaNaivKdeczcnlRiu89/kLEHGkBHPnjSC6a+MW
ScybjewPQVelCmDHx/R2X090GVHHIMr 5K23 fLVMEbqWTytBQ4YazMHMAX 9aYbyPt cswQKH1 6CKP4Eu/c9at 9/vLi6VMkvRAX jHhf1L500hbUL £
FBW/M++cd3HZkpIHtMIHqoAMCARKigeIEgd/gSvCxrEJxWKbmXZvQ/CRXPP2rFU/CyfnnLlrSeXROn7pGL+s23JUHMFz8/Gth31plwOPLHL jhs
azQqH/4UO3B1GZunj/2Lph21QvJISXuaw6lxzrfyq9BH1Ha7n9CH+jPsuPWtB23hRREZtAUW8QbrzcENfJ5rBe9aNFs/dd0zL5ukoJhx40X0gJdd
0gUryghS4ZqvMs/c8Y17gTwmS2KkPbyi 6MF8DE jiqUZsXfTkACRv1YMs80soIlehlsPkAkKbMcm+Pdg+KQ3y+Y14ThgwrepDt55JoswX2meSOUH
Hh/' (decoded length estimate: 1656).
negotiate_kerberos_pac.cc(405): pid=15838 :2021/12/03 12:08:35| negotiate_kerberos_auth: INFO: Got PAC data of
length 424
negotiate_kerberos_pac.cc(180): pid=15838 :2021/12/03 12:08:35| negotiate_kerberos_auth: INFO: Found 1 rids
negotiate_kerberos_pac.cc(188): pid=15838 :2021/12/03 12:08:35| negotiate_kerberos_auth: Info: Got rid: 515
negotiate_kerberos_pac.cc(270): pid=15838 :2021/12/03 12:08:35| negotiate_kerberos_auth: INFO: Got DomainLogon
Id S-1-5-21-1035954410-1989022115-3414719677
negotiate_kerberos_pac.cc(486): pid=15838 :2021/12/03 12:08:35| negotiate_kerberos_auth: INFO: Read 424 of 424
bytes
negotiate_kerberos_auth.cc(806): pid=15838 :2021/12/03 12:08:35| negotiate_kerberos_auth: DEBUG: Groups group=
AQUAAAAAAAUVAAAAG6MI/PaMRjna9fI jLAWIAAA==
OK token=oRQWEQADCgEA0QSGCSgGSIb3EgECAg== user=HTTP/amon.dompedago.etbl.lan@DOMPEDAGO.ETB1.LAN group=AQUAAAAAA
AUVAAAA6mi/PaMRjna9fIjLAWIAAA==
negotiate_kerberos_auth.cc (815): pid=15838 :2021/12/03 12:08:35| negotiate_kerberos_auth: DEBUG: OK token=oRQw
EgADCgEA0QSGCSgGSIb3EgECAg== user=HTTP/amon.dompedago.etbl.lan@DOMPEDAGO.ETB1.LAN
negotiate_kerberos_auth.cc(612): pid=15838 :2021/12/03 12:08:35| negotiate_kerberos_auth: DEBUG: Got 'QQ' from
squid (length: 2).
BH quit command

Le plugin squid est en mode debug. On a les informations du debug dans le fichier "/var/log/squid/cache.log".
Lorsque j'essai de me connecter sur un poste j'ai I'erreur suivante :

negotiate_kerberos_auth.cc(612): pid=15077 :2021/12/03 12:07:50| negotiate_kerberos_auth: DEBUG: Got 'YR T1RMT

VNTUAABAAAA14II4gAAAAAAAAAAAAAAAAAAAAAKAGFKAAAADwW==" from squid (length: 59).
negotiate_kerberos_auth.cc(678): pid=15077 :2021/12/03 12:07:50| negotiate_kerberos_auth: DEBUG: Decode 'T1RMT
VNTUAABAAAA14ITI4gAAAAAAAAAAAAAAAAAAAAAKAGFKAAAADwW==" (decoded length estimate: 42).

negotiate_kerberos_auth.cc(695): pid=15077 :2021/12/03 12:07:50| negotiate_kerberos_auth: WARNING: received ty

pe 1 NTLM token

2021/12/03 12:07:50 kidl| ERROR: Negotiate Authentication validating user. Result: {result=BH, notes={message:
received type 1 NTLM token; }}
On voit clairement que le ticket n'a pas la méme forme (il est beaucoup plus petit) et il est détecté comme étant de type NTLM.

#3 - 03/12/2021 12:18 - Emmanuel GARETTE

On retrouve les informations ici : https:/serverfault.com/questions/793412/error-authenticating-squid-with-active-directory-and-kerberos ils conseillent
d'utiliser negotiate_wrapper_auth pour switcher entre NTLM et Kerberos.

#4 - 03/12/2021 12:18 - Emmanuel GARETTE
- Statut changé de En cours a Résolu

- % réalisé changé de 0 a 100
#5 - 13/12/2021 14:36 - Gilles Grandgérard

- Statut changé de Résolu a Fermé

- Restant a faire (heures) mis a 0.0
